//	main.c
//	SDSF
//
//	Created by Nils Daumann on 25.06.11.
//	Copyright (c) 2011 Nils Daumann (www.slindev.com)

//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:

//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.

//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.

#include <acknex.h>
#include <default.c>

//force compiling at runtime
//#define SDSF_IGNORE_COMPILED

//force precompiling of shaders
//#define SDSF_COMPILE

//include the FXAA effect before using it
#include "slindev/modules/pp_fxaa3.c"

void main()
{
	//load a level
	level_load("assets/techbox.mdl");
	
	//activate FXAA
	pp_fxaa3_push(camera);
	
	//toggle FXAA by pressing F
	char active = 1;
	while(1)
	{
		if(key_f)
		{
			if(active)
			{
				//deactivate FXAA
				pp_fxaa3_remove(camera);
				active = 0;
			}else
			{
				//activate FXAA
				pp_fxaa3_push(camera);
				active = 1;
			}
		}
		while(key_f){wait(1);}
		
		wait(1);
	}
}