//	pp_fxaa3.c
//	SDSF
//
//	Created by Nils Daumann on 25.06.11.
//	Copyright (c) 2011 Nils Daumann (www.slindev.com)

//	Permission is hereby granted, free of charge, to any person obtaining a copy
//	of this software and associated documentation files (the "Software"), to deal
//	in the Software without restriction, including without limitation the rights
//	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//	copies of the Software, and to permit persons to whom the Software is
//	furnished to do so, subject to the following conditions:

//	The above copyright notice and this permission notice shall be included in
//	all copies or substantial portions of the Software.

//	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//	THE SOFTWARE.

#ifndef __PP_FXAA3_C__
#define __PP_FXAA3_C__

#include "slindev/common/sdsf_shared.c"
#include "slindev/common/sdsf_pp.c"

MATERIAL *pp_fxaa_mat_lum = NULL;
MATERIAL *pp_fxaa_mat_aa = NULL;

/**
 * Add to chain.
 * Adds the effect to the given views postprocessing chains end.
 * @param view a pointer to a view of the chain, this effect is meant to be added to.
 */
void pp_fxaa3_push(VIEW *view)
{
	if(pp_fxaa_mat_lum == NULL)
		pp_fxaa_mat_lum = sdsf_mtl_create("slindev/shaders/pp_fxaa3_luma.fxo");
	sdsf_pp_push(camera, pp_fxaa_mat_lum);
	
	if(pp_fxaa_mat_aa == NULL)
		pp_fxaa_mat_aa = sdsf_mtl_create("slindev/shaders/pp_fxaa3_aa.fxo", "FXAA_PC=1 FXAA_HLSL_3=1 FXAA_LINEAR=1");
	sdsf_pp_push(camera, pp_fxaa_mat_aa);
}

/**
 * Remove from chain.
 * Removes the effect from the given views postprocessing chain.
 * @param view a pointer to a view of the chain, this effect is meant to be removed from.
 */
void pp_fxaa3_remove(VIEW *view)
{
	sdsf_pp_remove(camera, pp_fxaa_mat_lum);
	sdsf_pp_remove(camera, pp_fxaa_mat_aa);
}

#endif